Index: trunk/src/VBox/Devices/Makefile.kmk
===================================================================
--- trunk/src/VBox/Devices/Makefile.kmk	(revision 45974)
+++ trunk/src/VBox/Devices/Makefile.kmk	(revision 46035)
@@ -97,8 +97,4 @@
  	$(PATH_SDK_$(VBOX_WINDDK)_LIB)/Newdev.lib
  endif
- ifeq ($(KBUILD_TARGET),l4)
-  VBoxDDU_LIBS           += \
- 	$(L4_LIBDIR)/libl4sys.p.a
- endif
  VBoxDDU_LDFLAGS.darwin   = -install_name $(VBOX_DYLD_EXECUTABLE_PATH)/VBoxDDU.dylib
  ifdef VBOX_WITH_USB
@@ -109,15 +105,4 @@
 
  VBoxDDU_LDFLAGS.linux    = -Wl,--no-undefined
- VBoxDDU_LDFLAGS.l4       = -Wl,--no-undefined
-
- #
- # VBoxDDULnxHostR3 (Only needed for l4, currently for executing vditool on L4Linux.)
- #
- ifeq ($(KBUILD_TARGET),l4)
-  LIBRARIES                += VBoxDDULnxHostR3
-  VBoxDDULnxHostR3_TEMPLATE = VBOXLNXHOSTR3LIB
-  VBoxDDULnxHostR3_DEFS     = IN_VBOXDDU
-  VBoxDDULnxHostR3_SOURCES  = $(VBoxDDU_SOURCES)
- endif
 
  #
@@ -212,5 +197,4 @@
  	-framework DiskArbitration
  VBoxDD_LDFLAGS.linux    = -Wl,--no-undefined
- VBoxDD_LDFLAGS.l4       = -Wl,--no-undefined
 
  # --- Tracing bits. ---
@@ -287,9 +271,4 @@
  	$(if $(VBOX_USB_WITH_SYSFS),VBOX_USB_WITH_SYSFS,)
   VBoxDD_SOURCES.linux  += \
- 	USB/USBProxyDevice.cpp \
- 	USB/linux/USBProxyDevice-linux.cpp
-
-  VBoxDD_DEFS.l4        += VUSB_HAVE_USBPROXY_DEVICE
-  VBoxDD_SOURCES.l4     += \
  	USB/USBProxyDevice.cpp \
  	USB/linux/USBProxyDevice-linux.cpp
@@ -599,11 +578,4 @@
  endif # freebsd
 
- ifeq ($(KBUILD_TARGET),l4)
-  $(error L4 is busted. Fix when needed.)
-  #VBoxDD_SOURCES      = filter needed
-  VBoxDD_SOURCES.l4    += \
-  	Audio/ossaudio.c
- endif # l4
-
  VBoxDD_SOURCES.linux  += \
  	Network/DrvTAP.cpp \
@@ -659,8 +631,4 @@
  	$(VBoxDDU_1_STAGE_TARGET) \
  	$(VBoxDD2_1_STAGE_TARGET)
- endif
- ifeq ($(KBUILD_TARGET),l4)
-  VBoxDD_LIBS           += \
- 	$(L4_LIBDIR)/libl4sys.p.a
  endif
 
@@ -883,12 +851,7 @@
  	$(LIB_VMM) \
  	$(LIB_RUNTIME)
- ifeq ($(KBUILD_TARGET),l4)
- VBoxDD2_LIBS           += \
- 	$(L4_LIBDIR)/libl4sys.p.a
- endif
  VBoxDD2_LIBS.darwin    += $(LIB_REM)
  VBoxDD2_LDFLAGS.darwin  = -install_name $(VBOX_DYLD_EXECUTABLE_PATH)/VBoxDD2.dylib
  VBoxDD2_LDFLAGS.linux   = -Wl,--no-undefined
- VBoxDD2_LDFLAGS.l4      = -Wl,--no-undefined
 
  ifdef VBOX_WITH_PXE_ROM
Index: trunk/src/VBox/Devices/Network/DrvTAP.cpp
===================================================================
--- trunk/src/VBox/Devices/Network/DrvTAP.cpp	(revision 45974)
+++ trunk/src/VBox/Devices/Network/DrvTAP.cpp	(revision 46035)
@@ -63,8 +63,4 @@
 #include <errno.h>
 #include <unistd.h>
-
-#ifdef RT_OS_L4
-# include <l4/vboxserver/file.h>
-#endif
 
 #include "VBoxDD.h"
Index: trunk/src/VBox/Devices/Storage/DrvHostDVD.cpp
===================================================================
--- trunk/src/VBox/Devices/Storage/DrvHostDVD.cpp	(revision 45974)
+++ trunk/src/VBox/Devices/Storage/DrvHostDVD.cpp	(revision 46035)
@@ -34,7 +34,4 @@
 # include <mach/mach_error.h>
 # define USE_MEDIA_POLLING
-
-#elif defined(RT_OS_L4)
-/* nothing (yet). */
 
 #elif defined RT_OS_LINUX
@@ -438,8 +435,4 @@
         rc = VERR_DEV_IO_ERROR;
 
-#elif defined(RT_OS_L4)
-    /* Not really ported to L4 yet. */
-    rc = VERR_INTERNAL_ERROR;
-
 #elif defined(RT_OS_LINUX)
     int direction;
@@ -778,5 +771,4 @@
 #endif
 
-#ifndef RT_OS_L4 /* Passthrough is not supported on L4 yet */
             bool fPassthrough;
             rc = CFGMR3QueryBool(pCfg, "Passthrough", &fPassthrough);
@@ -786,5 +778,5 @@
                 /* Passthrough requires opening the device in R/W mode. */
                 pThis->fReadOnlyConfig = false;
-# ifdef VBOX_WITH_SUID_WRAPPER  /* Solaris setuid for Passthrough mode. */
+#ifdef VBOX_WITH_SUID_WRAPPER  /* Solaris setuid for Passthrough mode. */
                 rc = solarisCheckUserAuth();
                 if (RT_FAILURE(rc))
@@ -793,7 +785,6 @@
                     return rc;
                 }
-# endif /* VBOX_WITH_SUID_WRAPPER */
+#endif /* VBOX_WITH_SUID_WRAPPER */
             }
-#endif /* !RT_OS_L4 */
 
             pThis->IMount.pfnUnmount = drvHostDvdUnmount;