Index: /trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp
===================================================================
--- /trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp	(revision 46088)
+++ /trunk/src/VBox/VMM/VMMR0/HMVMXR0.cpp	(revision 46089)
@@ -3849,8 +3849,8 @@
 
 #ifdef VBOX_STRICT
-                Log(("uExitReason        %#x (VmxTransient %#x)\n", pVCpu->hm.s.vmx.lasterror.u32ExitReason,
-                                                                    pVmxTransient->uExitReason));
-                Log(("Exit Qualification %#x\n", pVmxTransient->uExitQualification));
-                Log(("InstrError         %#x\n", pVCpu->hm.s.vmx.lasterror.u32InstrError));
+                Log(("uExitReason        %#RX32 (VmxTransient %#RX16)\n", pVCpu->hm.s.vmx.lasterror.u32ExitReason,
+                     pVmxTransient->uExitReason));
+                Log(("Exit Qualification %#RX64\n", pVmxTransient->uExitQualification));
+                Log(("InstrError         %#RX32\n", pVCpu->hm.s.vmx.lasterror.u32InstrError));
                 if (pVCpu->hm.s.vmx.lasterror.u32InstrError <= HMVMX_INSTR_ERROR_MAX)
                     Log(("InstrError Desc.  \"%s\"\n", g_apszVmxInstrErrors[pVCpu->hm.s.vmx.lasterror.u32InstrError]));
@@ -4815,9 +4815,9 @@
     if (!(pVCpu->hm.s.vmx.fUpdatedGuestState & HMVMX_UPDATED_GUEST_RIP))
     {
-        uint64_t uVal = 0;
-        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_RIP, &uVal);
+        uint64_t u64Val = 0;
+        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_RIP, &u64Val);
         AssertRCReturn(rc, rc);
 
-        pMixedCtx->rip = uVal;
+        pMixedCtx->rip = u64Val;
         pVCpu->hm.s.vmx.fUpdatedGuestState |= HMVMX_UPDATED_GUEST_RIP;
     }
@@ -4842,9 +4842,9 @@
     if (!(pVCpu->hm.s.vmx.fUpdatedGuestState & HMVMX_UPDATED_GUEST_RSP))
     {
-        uint64_t uVal = 0;
-        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_RSP, &uVal);
+        uint64_t u64Val = 0;
+        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_RSP, &u64Val);
         AssertRCReturn(rc, rc);
 
-        pMixedCtx->rsp = uVal;
+        pMixedCtx->rsp = u64Val;
         pVCpu->hm.s.vmx.fUpdatedGuestState |= HMVMX_UPDATED_GUEST_RSP;
     }
@@ -4977,15 +4977,15 @@
     }
 
-    uint64_t uGCVal = 0;
+    uint64_t u64Val = 0;
     if (!(pVCpu->hm.s.vmx.fUpdatedGuestState & HMVMX_UPDATED_GUEST_SYSENTER_EIP_MSR))
     {
-        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_SYSENTER_EIP, &uGCVal);    AssertRCReturn(rc, rc);
-        pMixedCtx->SysEnter.eip = uGCVal;
+        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_SYSENTER_EIP, &u64Val);    AssertRCReturn(rc, rc);
+        pMixedCtx->SysEnter.eip = u64Val;
         pVCpu->hm.s.vmx.fUpdatedGuestState |= HMVMX_UPDATED_GUEST_SYSENTER_EIP_MSR;
     }
     if (!(pVCpu->hm.s.vmx.fUpdatedGuestState & HMVMX_UPDATED_GUEST_SYSENTER_ESP_MSR))
     {
-        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_SYSENTER_ESP, &uGCVal);    AssertRCReturn(rc, rc);
-        pMixedCtx->SysEnter.esp = uGCVal;
+        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_SYSENTER_ESP, &u64Val);    AssertRCReturn(rc, rc);
+        pMixedCtx->SysEnter.esp = u64Val;
         pVCpu->hm.s.vmx.fUpdatedGuestState |= HMVMX_UPDATED_GUEST_SYSENTER_ESP_MSR;
     }
@@ -5011,7 +5011,7 @@
     if (!(pVCpu->hm.s.vmx.fUpdatedGuestState & HMVMX_UPDATED_GUEST_FS_BASE_MSR))
     {
-        uint64_t uVal = 0;
-        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_FS_BASE, &uVal);   AssertRCReturn(rc, rc);
-        pMixedCtx->fs.u64Base = uVal;
+        uint64_t u64Val = 0;
+        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_FS_BASE, &u64Val);   AssertRCReturn(rc, rc);
+        pMixedCtx->fs.u64Base = u64Val;
         pVCpu->hm.s.vmx.fUpdatedGuestState |= HMVMX_UPDATED_GUEST_FS_BASE_MSR;
     }
@@ -5037,7 +5037,7 @@
     if (!(pVCpu->hm.s.vmx.fUpdatedGuestState & HMVMX_UPDATED_GUEST_GS_BASE_MSR))
     {
-        uint64_t uVal = 0;
-        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_GS_BASE, &uVal);   AssertRCReturn(rc, rc);
-        pMixedCtx->gs.u64Base = uVal;
+        uint64_t u64Val = 0;
+        rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_GS_BASE, &u64Val);   AssertRCReturn(rc, rc);
+        pMixedCtx->gs.u64Base = u64Val;
         pVCpu->hm.s.vmx.fUpdatedGuestState |= HMVMX_UPDATED_GUEST_GS_BASE_MSR;
     }
@@ -5125,12 +5125,12 @@
                 && CPUMIsGuestPagingEnabledEx(pMixedCtx)))
         {
-            uint64_t uVal = 0;
-            rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_CR3, &uVal);
-            if (pMixedCtx->cr3 != uVal)
+            uint64_t u64Val = 0;
+            rc = VMXReadVmcsGstN(VMX_VMCS_GUEST_CR3, &u64Val);
+            if (pMixedCtx->cr3 != u64Val)
             {
-                CPUMSetGuestCR3(pVCpu, uVal);
+                CPUMSetGuestCR3(pVCpu, u64Val);
                 if (VMMRZCallRing3IsEnabled(pVCpu))
                 {
-                    PGMUpdateCR3(pVCpu, uVal);
+                    PGMUpdateCR3(pVCpu, u64Val);
                     Assert(!VMCPU_FF_IS_PENDING(pVCpu, VMCPU_FF_HM_UPDATE_CR3));
                 }